<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <link href="https://brendan.ie/main.css" rel="stylesheet">

    <title>Better M7</title>

    <meta content="Better M7" name="title">
    <meta content="Brendan Golden" name="author">
    <meta content="A better source of data than the M7 app" name="description">

    <!-- for mobile devices -->
    <meta content="width=device-width,initial-scale=1" name="viewport">
    <!-- brendan.coffee -->
    <link href="https://brendan.ie/coffee/coffee.css" rel="stylesheet">
    <script src="https://brendan.ie/coffee/coffee.js"></script>
  </head>
  <body class="sticky-wrapper">
    <div id="coffee_anchor"><span id="served"></span></div>
    <script>C0FFEE()</script>

    <header>
      <h1>Brendan's Better M7</h1>
    </header>
    <main id="anchor">
      <p>
        I got fed up with waiting for a bus only for "No Data" to appear in the app, so I made this.
        <br/>
        2022-07-13: Still better than the tracking on the website for oh so many reasons.
        <br/>
        2023-09-05: Better "UI", can select a particular station.
        <br/>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        Not start/end stations as I have no data on those other than the timetable.
        <br/>
      </p>
    </main>
    <footer>
      <span>
        Built with coffee and spite one evening.
        <a href="https://gitlab.com/silver_rust/better-300" rel='noopener noreferrer'
           target='_blank'>API source.</a>
        <a href="https://gitlab.com/brendan.ie/v1/-/blob/main/src/bus.html" rel='noopener noreferrer'
           target='_blank'>Page source.</a>
      </span>
      <br/>
      <span>
        © 2021-<span id="year">2021</span> | <wbr/>
        Brendan Golden | <wbr/>
        Email: contact_me(at symbol)brendan.ie <a href="mailto:contact_website@brendan.ie"></a><a href="mailto:contact@brendan.ie"></a>  | <wbr/>
        Gitlab: <a href="https://gitlab.com/Brendan_Golden">Brendan_Golden</a> | <wbr/>
        Discord: Silver#5563 | <wbr/>
        Mastodon: <a rel="me" href="https://mastodon.brendan.ie/@silver">@silver</a>
      </span>
    </footer>
    <script>
      /* I am a lazy fucker */
      document.getElementById('year').textContent = new Date().getFullYear().toString()
    </script>
    <script>

      const places = [
        'University of Limerick',
        'Arthurs Quay Limerick',
        'Bunratty',
        'Kildare Village'
      ]

      let data_processed = [];

      // defaults to UL
      let selected_place = 'University of Limerick';

      run_setup()

      // firstrun only
      async function run_setup () {
        // process the hash
        selected_place = get_hash();

        // load the buttons and dropdowns
        setup_ui();

        // get the fresh data
        await fetch_data();

        // create a table just for that data
        table_generate()
      }

      // each time its refreshed
      async function run () {
        await fetch_data();
        table_generate()
      }

      function setup_ui() {
        const anchor = document.getElementById('anchor');

        const list = document.createElement('select');
        for (let place of places) {
          const list_item = document.createElement('option');
          list_item.id = `${place}_dropdown`;
          list_item.value = place;
          list_item.innerText = place;
          list.appendChild(list_item);
        }
        list.id = "dropdown"
        list.addEventListener("change", handle_selection);

        anchor.appendChild(list);
        document.getElementById(`${selected_place}_dropdown`).selected = true;

        const btn = document.createElement('button');
        btn.type = "button";
        btn.addEventListener("click", run);
        btn.innerText = "Refresh.";
        anchor.appendChild(btn);

        anchor.appendChild(document.createElement('br'));
        anchor.appendChild(document.createElement('br'));
      }

      function handle_selection() {
        let value_new = document.getElementById("dropdown").value;
        if (selected_place !== value_new) {
          selected_place = value_new;
          window.location.hash = value_new;
          table_generate();
        }
      }

      async function fetch_data() {
        let result = await fetch('https://api.brendan.ie/bus')
        // get the data
        .then((response) => {
          if (!response.ok) {
            console.error(`HTTP error! Status: ${response.status}`)
            return []
          }
          return response.json()
        })
        .catch((err) => {
          console.log(err);
          return []
        })
        data_processed = reduce_down(result);
      }

      function reduce_down (data) {
        let tmp = {}
        for (let element of data) {
          let id = `${element['journey_id']}_${element['journey_no']}_${element['place_from']}_${element['place_to']}`

          // this is the default time for any bus that is listed as "no data" and never updated afterwards
          if (element['valid_estimate'] === 7960094222) {
            continue
          }

          if (typeof tmp[id] === 'undefined') {
            tmp[id] = element
            continue
          }

          if (element['valid_timestamp'] > tmp[id]['valid_timestamp']) {
            tmp[id] = element
          }
        }
        return Object.values(tmp)
      }

      function table_generate () {
        // remove existing table (if exists)
        table_delete()
        // create a new table
        let table = table_create()
        table_create_head(table)
        table_create_body(table)
      }

      // delete all existing tables
      function table_delete () {
        for (let place of places) {
          let table = document.getElementById(place)
          if (!table) {
            continue
          }
          table.remove()
        }
      }

      function table_create () {
        const table = document.createElement('table')

        const div = document.createElement('div')
        div.id = selected_place
        div.appendChild(table)
        div.appendChild(document.createElement('br'))

        const anchor = document.getElementById('anchor')
        anchor.appendChild(div)

        return table
      }

      function get_hash() {
        // if there is no hash set then set it to UL
        if (!window.location.hash) {
          window.location.hash = 'University of Limerick';
        }

        let tmp = window.location.hash.replace("#", "")
        let decoded = decodeURI(tmp);
        if (places.includes(decoded)) {
          return decoded
        }

        return selected_place;
      }

      // thanks to https://www.valentinog.com/blog/html-table/ for some help
      function table_create_head (table) {
        const headers = [
          //"From",
          'To',
          'Last Update (App)',
          'App',
          'Estimate (min)',
        ]

        let thead = table.createTHead()
        let row_top = thead.insertRow()

        let last_update = document.createElement('th')
        last_update.appendChild(document.createTextNode(selected_place))
        last_update.style = 'width: 170px'
        row_top.appendChild(last_update)

        let last_update_date = document.createElement('th')
        last_update_date.appendChild(document.createTextNode(''))
        last_update_date.colSpan = headers.length - 1
        last_update_date.id = `${selected_place}_last_update`
        row_top.appendChild(last_update_date)

        // add the second row
        let row = thead.insertRow()
        for (let key of headers) {
          let th = document.createElement('th')
          let text = document.createTextNode(key)
          th.appendChild(text)
          if (key === 'To') {
            th.style = 'width: 170px'
          }
          row.appendChild(th)
        }
      }

      function table_create_body (table) {

        // only show the type of results for this table
        let data = data_processed
        .filter(item => item['place_from'] === selected_place)
        .sort((a, b) => a['valid_estimate'] - b['valid_estimate'])

        let now = Date.now() / 1000
        let last_update = 0

        outer: for (let element of data) {
          let row = table.insertRow()

          if (typeof element['valid_timestamp'] !== 'undefined') {
            if (element['valid_timestamp'] > last_update) {
              last_update = element['valid_timestamp']
            }
          }

          const valid = [
            //"place_from",
            'place_to',
            'valid_timestamp',
            //"journey_id",
            //"journey_no",
            'last_arriving',
            //"last_timestamp",
            'valid_estimate',
          ]
          for (let key of valid) {
            if (typeof element[key] === 'undefined') {
              continue outer
            }

            let cell = row.insertCell()
            if (key === 'place_to') {
              cell.style = 'width: 170px'
            }

            let inner_text = element[key]

            if (key === 'valid_estimate') {
              inner_text = Math.round((element[key] - now) / 60)
            }
            if (key === 'valid_timestamp') {
              inner_text = Math.round((now - element[key]) / 60)
            }

            let text = document.createTextNode(inner_text)
            cell.appendChild(text)
          }
        }

        let header = document.getElementById(`${selected_place}_last_update`)
        header.innerText = new Date(last_update * 1000).toString()
      }

    </script>
  </body>
</html>